#include "MBRParser.h"
#include "common.h"

MBRParser::MBRParser(FILE* rawDisk, unsigned long long offset) {
  unsigned char buffer[512];
  fseeko(rawDisk, offset, SEEK_SET);
  fread(buffer, 1, 512, rawDisk);

  for(int i = 0; i < 4; i++) {
    int type = buffer[450 + (i*16)];
    unsigned long long start = get_dword(&buffer[454 + (i*16)]);
    partitions.push_back(new Partition(rawDisk, start*512, type));
  }
}

MBRParser::~MBRParser() {
  for(unsigned int i = 0; i < partitions.size(); i++) {
    delete partitions[i];
  }
}

vector<Directory*> MBRParser::getRoots() {
  vector<Directory*> directories;
  for(unsigned int i = 0; i < partitions.size(); i++) {
    directories.push_back(partitions[i]->getRoot());
  }
  return directories;
}

