#include "Partition.h"
#include "FilesystemParser.h"

#include "ntfs/NTFSParser.h"
#include "fat/FATParser.h"

Partition::Partition(FILE* device, unsigned long long start, int type) {
  printf("Creating partition at %llu\n", start);

  this->device = device;
  this->start  = start;
  this->type   = type;
}

Directory* Partition::getRoot() {
  FilesystemParser* parser = NULL;
  if(type == 7) {
    parser = new NTFSParser(device, start);
  }
  else if(type == 0x0b || type == 0x0c || type == 0x0f) {
    parser = new FATParser(device, start);
  }

  if(parser != NULL) {
    return parser->getRoot();
  }
  else {
    return NULL;
  }
}

