#ifndef FATPARSER_H
#define FATPARSER_H

#include <stdio.h>
#include <string>
#include "../filesystem/Directory.h"
#include "../FilesystemParser.h"

using std::string;

class FATParser : public FilesystemParser {
public:
  FATParser(FILE* rawDisk, unsigned long long offset);
  virtual Directory* getRoot();

private:
  int sectorsPerCluster;
  int reservedSectors;
  int fileAllocationTables;
  unsigned long long firstSector;
  unsigned long long partitionStart;
  FILE* device;

  void enumerateNode(Directory* node, unsigned long long cluster, unsigned long long pos);
  string getFilename(unsigned char* buf);
  unsigned long long FATE(unsigned long long cluster);
};

#endif

