#include "Directory.h"
#include <stdio.h>

Directory::Directory(const char* dirname, Node* parent) : Node(dirname, parent) {
}

Directory::~Directory() {
  for(unsigned int i = 0; i < children.size(); i++) {
    delete children[i];
  }
}

Directory* Directory::asDirectory() {
  return this;
}

void Directory::print() {
	if(parent != NULL) {
		parent->print();
	}
	printf("%s\\", cname);
}

void Directory::addNode(Node* node) {
  children.push_back(node);
}

vector<File*> Directory::getFiles() {
  vector<File*> files;
  for(unsigned int i = 0; i < children.size(); i++) {
    File* file = children[i]->asFile();

    if(file) {
      files.push_back(file);
    }
  }

  return files;
}

vector<Directory*> Directory::getDirectories() {
  vector<Directory*> dirs;
  for(unsigned int i = 0; i < children.size(); i++) {
    Directory* dir = children[i]->asDirectory();

    if(dir) {
      dirs.push_back(dir);
    }
  }

  return dirs;

	return dirs;
}

