#ifndef FORK_H
#define FORK_H

#include "../common.h"
#include "ClusterRun.h"
#include "../DeviceInformation.h"
#include "PostReadProcessor.h"
#include <vector>

using std::vector;

class Fork {
public:
  Fork(const char* name, DeviceInformation* device, vector<ClusterRun> clusters);

  byte* getData();
  void addPostReadProcessor(PostReadProcessor* processor);

private:
  vector<PostReadProcessor*> processors;
  vector<ClusterRun> clusters;
  const char* name;
  DeviceInformation* device;
};

#endif
