#ifndef NODE_H
#define NODE_H

#include "Fork.h"
#include "FilePermissions.h"
#include "Timestamp.h"

class Directory;
class File;
class Symlink;

class Node {
public:
	Node(const char* name, Node* parent);
	virtual ~Node();
	
	virtual Directory* asDirectory();
	virtual File* asFile();
    virtual Symlink* asSymlink();
	virtual void print() = 0;
    virtual vector<Fork*> getForks();
    virtual Fork* getFork(const char* name);
    virtual void addFork(Fork* fork);
	char* getName();
    void setTimestamp(Timestamp* timestamp);
    Timestamp* getTimestamp();
    virtual void setPermissions(FilePermissions* permissions);
    virtual FilePermissions* getPermissions();
	
protected:
	char* cname;
	Node* parent;
    Timestamp* timestamp;
    vector<Fork*> forks;
    FilePermissions* permissions;
};

#endif

