#include "DataRun.h"

#include <stdio.h>

NTFSDataRun::NTFSDataRun(byte* run, unsigned long long previousRunOffset) {
  if(*run == 0) {
    length = 0;
    offset = 0;
    return;
  }

  int lengthLength = *run % 16;
  int offsetLength = *run >> 4;

  runLength = (1 + lengthLength + offsetLength);

  run++;

  length = get_bytes(run, lengthLength);
  run += lengthLength;

  offset = get_bytes(run, offsetLength);
  offset += previousRunOffset;
}

void NTFSDataRun::print() {
  printf(" (%ld %llu) ", getLength(), getLCNOffset());
}

int NTFSDataRun::getRunLength() {
  return runLength;
}

long NTFSDataRun::getLength() {
  return length;
}

unsigned long long NTFSDataRun::getLCNOffset() {
  return offset;
}

