#include "FilenameAttribute.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

NTFSFilenameAttribute::NTFSFilenameAttribute(DeviceInformation* device, byte* offset, int mftRecordOffset) 
  : NTFSAttribute(device, offset, mftRecordOffset)
{
    int filenameLength = offset[getHeaderLength() + 0x40];
    filename = (char*)malloc(filenameLength + 1);

    for(int i = 0; i < filenameLength; i++) {
      filename[i] = offset[0x18 + 0x42 + (i*2)];
    }
    filename[filenameLength] = 0;
}

NTFSFilenameAttribute::~NTFSFilenameAttribute() {
  free(filename);
}

const char* NTFSFilenameAttribute::getRawFilename() {
  return filename;
}

void NTFSFilenameAttribute::print() {
  printf("Filename:\t%s\n", filename);
}

int NTFSFilenameAttribute::length() {
  return strlen(filename);
}

