// =====================================================================================
// 
//       Filename:  IndexEntry.cpp
// 
//    Description:  Contains the implementation of the class which is used to represent 
//                  a single entry in a directory for the NTFS file system.
// 
//        Version:  1.0
//        Created:  07/08/09 01:50:07
//       Revision:  none
//       Compiler:  g++
// 
//         Author:  Benjamin Kearns (), benjamin.kearns@gmail.com
// 
// =====================================================================================

#include "IndexEntry.h"
#include <stdlib.h>
#include <stdio.h>
#include "../common.h"

IndexEntry::IndexEntry(unsigned char* entry) {
  // the size of the record will be 0x10 if it's the last record.
	//filename = NULL;
  length = get_word(&entry[0x08]);
  if(length == 0x10) {
    return;
  }

  fileReference = get_6bytes(entry);
  /*filenameLength = entry[0x50];
	
	if(filenameLength != 0) {
		filename = (char*)malloc(filenameLength + 1);
		for(int i = 0; i < filenameLength; i++) {
			filename[i] = entry[0x52 + (i*2)];
		}
		filename[filenameLength] = 0;
	}*/
}

IndexEntry::~IndexEntry() {
	/*if(filename != NULL) {
		free(filename);
	}*/
}

void IndexEntry::print() {
	//printf("%llu: \t %s\n", fileReference, filename);
}

/*char* IndexEntry::getFilename() {
	return filename;
}*/

bool IndexEntry::isLast() {
  return length == 0x10;
}

int IndexEntry::getLength() {
  return length;
}

unsigned long long IndexEntry::getFileReference() {
  return fileReference;
}
