// =====================================================================================
// 
//       Filename:  IndexEntry.h
// 
//    Description:  Contains a single index entry, for a directory in the NTFS file system.
// 
//        Version:  1.0
//        Created:  07/08/09 01:22:09
//       Revision:  none
//       Compiler:  g++
// 
//         Author:  Benjamin Kearns (), benjamin.kearns@gmail.com
// 
// =====================================================================================

#ifndef INDEXENTRY_H
#define INDEXENTRY_H

class IndexEntry {
public:
  IndexEntry(unsigned char* entry);
  ~IndexEntry();

  bool isLast();
  int getLength();
  unsigned long long getFileReference();
	//char* getFilename();
	void print();
private:
  unsigned long long fileReference;
  int flags;
  int length;
	//int filenameLength;
	//char* filename;
};

#endif
