#include <stdio.h>
#include "IndexRootAttribute.h"

#include "IndexEntry.h"

NTFSIndexRootAttribute::NTFSIndexRootAttribute(DeviceInformation* device, byte* offset, int mftRecordOffset) 
  : NTFSAttribute(device, offset, mftRecordOffset) {

  int offsetToIndexEntry = get_dword(&offset[getHeaderLength() + 0x10]);
  flags = offset[getHeaderLength() + 0x1C];
	
	//int size = get_dword(&offset[getHeaderLength() + 0x14]);
	
	/*printf("Size: %d\n", size);
	
	if(size == 32) {  // The length of the header by itself
		return;
	}*/

  offsetToIndexEntry += getHeaderLength();
	
  if(flags == 0) {
		IndexEntry entry = IndexEntry(&offset[offsetToIndexEntry]);
		while(!entry.isLast() && entry.getLength() != 0) {
			entries.push_back(entry);
			offsetToIndexEntry += entry.getLength();
			entry = IndexEntry(&offset[offsetToIndexEntry]);
		}
	}

}

vector<IndexEntry> NTFSIndexRootAttribute::getEntries() {
	return entries;
}

void NTFSIndexRootAttribute::print() {
  printf("Index Root Attribute:");
}

