#ifndef NTFSPARSER_H
#define NTFSPARSER_H

#include <stdio.h>
#include "../DeviceInformation.h"
#include "../FilesystemParser.h"
#include "Data.h"
#include "mftentry.h"
#include "../filesystem/Node.h"

class NTFSParser : public FilesystemParser
{
public:
    NTFSParser(FILE* rawDisk, unsigned long long partitionOffset);
    ~NTFSParser();

    Directory* getRoot();


private:
    MFTEntry* getMFTEntry(unsigned long long mftOffset);
    Node* getNode(unsigned long long mftEntryNumber, Node* parent);
		
    unsigned long long mftLength;
    DeviceInformation* device;
    unsigned char* mft;
	NTFSData mftData;

    int bytesPerSector;
    int sectorsPerClustor;
    int mediaDescriptor;
    int sectorsPerTrack;
    int numberOfHeads;
    int hiddenSectors;
    unsigned long long totalSectors;
    unsigned long long logicalClustorForMFT;
    unsigned long long logicalClustorForMFTMirr;
};

#endif

