#ifndef NTFSMFTENTRY_H
#define NTFSMFTENTRY_H

#include "../DeviceInformation.h"
#include "../common.h"
#include "Attribute.h"
#include "DataRun.h"
#include "IndexEntry.h"
#include "FilenameAttribute.h"
#include <stdio.h>
#include <vector>

using namespace std;

class MFTEntry {
public:
    MFTEntry(DeviceInformation* device, unsigned char* startOfMFT);
    ~MFTEntry();

    void print();
    void printDirectories();
    NTFSData getData();
    vector<IndexEntry> getIndexEntries();
    //NTFSFilenameAttribute* getFilename();
    const char* getFilename();
    bool isDirectory();
private:
    char magicMarker[5];
    int updateSequence1;
    int numEntriesInFixupArray;
    int sequenceNumber;
    int hardLinkCount;
    int firstAttribute;
    int flags;
    int usedSizeOfMFTEntry;
    int allocatedSizeOfMFTEntry;
    unsigned long long fileRecordNumber;
    int fileSequenceNumber;
    unsigned long long fileReference;
    int nextAttributeID;
    int numberOfEntry;
    
    vector<NTFSAttribute*> attributes;
};

#endif

